import java.util.*;
import java.io.*;

class MarkovMatrix{
	final int DIM=27;

	HashMap map = new HashMap(DIM*DIM);
	Random random = new Random();

	MarkovMatrix(){

		for(char z='a';z<='z';z++){
			for(char y='a';y<='z';y++){
				String key = "" + z + y;
				map.put(key,new double[DIM]);
			}
			String key = "" + z + " ";
			map.put(key,new double[DIM]);
		}

		for(char y='a';y<='z';y++){
			String key = " " + y;
			map.put(key,new double[DIM]);
		}
		map.put("  ",new double[DIM]);
	}

	public void addOne(char first, char second,char top){
			String key = "" + first + second;
			int i =( top == ' ' ? DIM-1 : top-'a');
			((double [])map.get(key))[i]++;
	}

	public void normalize(){
		Iterator it = map.values().iterator();
		while(it.hasNext())
			normArray(  (double [])it.next() );
	}

	private void normArray(double [] da){
		double sum=0;
		for(int i=0;i<da.length;i++)
			sum+=da[i];

		for(int i=0;i<da.length;i++)
			da[i]/=sum;
	}

	public void run(BufferedWriter br, int numIterations) throws IOException{
		char z2='a';
		char z1='a';
		char z= 'a';
		for(int i=0;i<numIterations;i++){
			z2=z1;
			z1=z;
			z=hagrala(z2,z1);
			br.write(z);

		}


	}

	//returns random letter
	private char hagrala(char z2, char z1){
		double [] arr =(double [])map.get(""+z2+z1);
		double  cum =0;
				char ch='a';
		double rand = random.nextDouble();
		for(int i=0;i<arr.length;i++){
			cum+=arr[i];
			if(rand < cum)
				break;
			ch++;
		}
		if(ch==('z'+1))
			ch= ' ';
		return ch;

	}


}